SystemOrganization addCategory: #'Pier-Exporter-Code'!

MAVisitor subclass: #PRCodeBuilderVisitor
	instanceVariableNames: 'structure stream methods exporter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Exporter-Code'!

PRCodeBuilderVisitor class
	instanceVariableNames: 'aComponent'!

PRCodeBuilderVisitor class
	instanceVariableNames: 'aComponent'!

!PRCodeBuilderVisitor class methodsFor: 'instance creation' stamp: 'NickAger 12/12/2011 20:19'!
structure: structure methods: methods exporter: exporter on: stream
	^ self basicNew
		initializeWithStructure: structure methods: methods exporter: exporter stream: stream
		yourself! !

!PRCodeBuilderVisitor methodsFor: 'private' stamp: 'NickAger 12/12/2011 15:15'!
addCodeFor: aDescription value: value
	aDescription accessor asCodeFor: structure description: aDescription value: value on: stream! !

!PRCodeBuilderVisitor methodsFor: 'modifying' stamp: 'NickAger 12/12/2011 12:29'!
addMethod: method
	self methods add: method! !

!PRCodeBuilderVisitor methodsFor: 'initialization' stamp: 'NickAger 12/12/2011 20:21'!
initializeWithStructure: aStructure methods: methodsCollection exporter:  anExporter stream: aStream
	self initialize.
	
	structure := aStructure.
	methods := methodsCollection.
	exporter := anExporter.
	stream := aStream! !

!PRCodeBuilderVisitor methodsFor: 'accessing' stamp: 'NickAger 12/12/2011 16:19'!
methods
	^ methods! !

!PRCodeBuilderVisitor methodsFor: 'visiting' stamp: 'NickAger 12/12/2011 15:16'!
visitDescription: aDescription
	| value |
	value := (aDescription accessor read: structure) asCode.
	self addCodeFor: aDescription value: value! !

!PRCodeBuilderVisitor methodsFor: 'visiting' stamp: 'NickAger 12/12/2011 15:15'!
visitDocumentDescription: aDescription
	"could have used:
		 value := (aDescription toString: (aDescription accessor read: structure)) asCode
	but I thought it was good to be explicit that we require wiki format output"
	| value |
	value := (PRWikiWriter write: (aDescription accessor read: structure)) asCode.
	self addCodeFor: aDescription value: value! !

!PRCodeBuilderVisitor methodsFor: 'visiting' stamp: 'NickAger 12/12/2011 15:19'!
visitFileDescription: aDescription
	| fileModel |
	fileModel := aDescription accessor read: structure.
	stream 
		<< '	structure file: ' << fileModel class greaseString << ' new
		filename: ' << fileModel filename asCode << ';
		mimetype: ' << fileModel mimetype asCode << ';
		filesize: ' << fileModel filesize asCode << ';
		contents: ' << (fileModel isText ifTrue: [ fileModel contents asString asCode ] ifFalse: [ fileModel contents greaseString ]) << '.'

! !

!PRCodeBuilderVisitor methodsFor: 'visiting' stamp: 'NickAger 12/12/2011 20:22'!
visitStructureDescription: aDescription
	| structureSelector subStructure |
	subStructure := aDescription accessor read: structure.
	structureSelector := exporter selectorFromStructure: subStructure.
	aDescription accessor asCodeFor: structure description: aDescription value: ' self ', structureSelector on: stream.
	self methods addAll: (exporter writeCodeFor: subStructure)! !

!Symbol methodsFor: '*pier-exporter-code' stamp: 'NickAger 12/12/2011 18:20'!
codeOn: aStream
	aStream << '#' << self! !

!PRDocumentAccessor methodsFor: '*pier-exporter-code' stamp: 'NickAger 12/11/2011 22:49'!
asCodeFor: structure description: description value: value on: stream
	stream << '	structure contents: ' << value << '.'! !

!MAAccessor methodsFor: '*pier-exporter-code' stamp: 'NickAger 12/11/2011 22:52'!
asCodeFor: structure description: description value: value on: stream
	| structureClass |
	structureClass := structure class greaseString.
	stream << '	' << structureClass << ' description detect: [ :each | each label = ''' << description label << ''' ]) accessor write: ' << value << ' to: structure. '! !

GRObject subclass: #PRKernelCodeExporter
	instanceVariableNames: 'selectorsWithCommonDefaults exportedMethods recursiveMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Exporter-Code'!

!PRKernelCodeExporter class methodsFor: 'instance creation' stamp: 'NickAger 12/12/2011 20:14'!
exportKernel: aKernel
	^ self new
		exportKernel: aKernel! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 12/12/2011 20:12'!
addKernelCreatorMethod: aKernel forComponent: component
	| method |
	method := String streamContents: [ :stream |
		stream << 'createKernel' << String cr
		 << '	^ PRKernel named: ''' << aKernel name << ''' root: self rootPage' ].
	self compileMethod: method intoComponent: component! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 12/12/2011 20:12'!
compileMethod: method intoComponent: component
	GRPlatform current 
		compile: method
		into: component
		classified: #'exported code'



! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 12/12/2011 20:12'!
compileMethods: methods intoComponent: component
	methods do: [ :method |
		self compileMethod: method intoComponent: component ]


! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 12/12/2011 20:24'!
exportKernel: aKernel
	| exportedCodeComponent rootComponent |
	exportedCodeComponent := GRObject
		subclass: (self selectorFromName: aKernel name, 'KernelCreator') capitalized  
		instanceVariableNames: ''
		classVariableNames: 'rootPage'
		poolDictionaries: ''
		category: 'Pier-Exported-Code'.
		
	self addKernelCreatorMethod: aKernel forComponent: exportedCodeComponent.
	
	rootComponent := aKernel root.
		
	GRPlatform current 
		compile: (self rootPageTemplate: rootComponent)
		into: exportedCodeComponent
		classified: #'exported code'.
		
	rootComponent enumerator with all do: [ :structure |
		| methods |
		methods := self writeCodeFor: structure.
		self compileMethods: methods intoComponent: exportedCodeComponent ]! !

!PRKernelCodeExporter methodsFor: 'initialization' stamp: 'NickAger 12/12/2011 20:25'!
initialize
 	super initialize.
	
	exportedMethods := Set new.
	recursiveMethods := Set new! !

!PRKernelCodeExporter methodsFor: 'helpers' stamp: 'NickAger 12/12/2011 20:12'!
isDefaultValueFor: aDescription on: structure
	| accessor isDefault |
	accessor := aDescription accessor.
	(accessor class canUnderstand: #readSelector) ifFalse: [ ^ false ].
	
	isDefault := self selectorsWithCommonDefaults at: accessor readSelector ifAbsent: [ ^ false ].
	^ isDefault value: structure
	
	! !

!PRKernelCodeExporter methodsFor: 'exporting' stamp: 'NickAger 12/12/2011 20:13'!
rootPageTemplate: rootComponent
	^ String streamContents: [ :stream | 
		stream << 'rootPage
	^ rootPage ifNil: [
		rootPage := self ' << (self selectorFromStructure: rootComponent) << ' ]']! !

!PRKernelCodeExporter methodsFor: 'helpers' stamp: 'NickAger 12/12/2011 20:13'!
selectorFromName: aName
	| selector |
	selector := aName select: [ :each | each isAlphaNumeric ].
	[ selector first isDigit ]
		whileTrue: [ selector := selector allButFirst ].
		
	selector at: 1 put: (selector at: 1) asLowercase.
		
	^ selector asSymbol! !

!PRKernelCodeExporter methodsFor: 'helpers' stamp: 'NickAger 12/12/2011 20:13'!
selectorFromStructure: structure
	| aName |
	aName := structure absolutePath.
	aName := (aName = '/') ifTrue: [ structure name ] ifFalse: [ aName ].
	
	^  self selectorFromName: aName
! !

!PRKernelCodeExporter methodsFor: 'private' stamp: 'NickAger 12/12/2011 20:13'!
selectorsWithCommonDefaults
	^ selectorsWithCommonDefaults ifNil: [ 
		selectorsWithCommonDefaults := Dictionary new
			at: #name put: [ :structure | true ];
			at: #title put: [ :structure | structure title = structure name capitalized ];
			at: #menu put: [ :structure | structure menu = structure title ];
			at: #tags put: [ :structure | structure tags isEmpty ];
			at: #hideFromMenus put: [ :structure | structure hideFromMenus not ];
			yourself ]! !

!PRKernelCodeExporter methodsFor: 'helpers' stamp: 'NickAger 12/12/2011 20:26'!
writeCodeFor: structure
	| methods method codeBuilder selector |
	selector := self selectorFromStructure: structure.
	
	"recursion guard"
	(exportedMethods includes: selector)
		ifTrue: [ recursiveMethods add: selector. ^ #() ]
		ifFalse: [ exportedMethods add: selector ].
	
	methods := OrderedCollection new.
	
	method :=  String streamContents: [ :stream | 
		stream << selector << '
	| structure  |
	structure := ' << structure class greaseString << ' named: ''' << structure name << '''.' << String cr.
	
		codeBuilder := PRCodeBuilderVisitor structure: structure methods: methods exporter: self on: stream.
		structure description do: [ :aDescription |
			| accessor |
			accessor := aDescription accessor.
			(((accessor canWrite: structure) 
				and: [(accessor read: structure) notNil ]) 
				and: [ (self isDefaultValueFor: aDescription on: structure) not ]) ifTrue: [
					codeBuilder visit: aDescription.
					stream nextPut: Character cr ] ].
			
			structure enumerator do: [ :each | 
				stream << '	structure addChild: self ' << (self selectorFromStructure: each) << '.' << String cr ].
			stream << '	^ structure' ].
	
	methods add: method.
	^ methods! !

!MASelectorAccessor methodsFor: '*pier-exporter-code' stamp: 'NickAger 12/11/2011 22:52'!
asCodeFor: structure description: description value: value on: stream
	stream << '	structure ' << self writeSelector greaseString << ' ' << value << '.'! !

!DateAndTime methodsFor: '*pier-exporter-code' stamp: 'NickAger 12/12/2011 19:28'!
codeOn: aStream
	aStream << '(' << self class greaseString << ' year: '; print: self year; << ' month: '; print: self month; << ' day: '; print: self day << ')' ! !

!Object methodsFor: '*pier-exporter-code' stamp: 'NickAger 12/12/2011 16:58'!
asCode
	^ String streamContents: [ :stream | self codeOn: stream ]! !

!Object methodsFor: '*pier-exporter-code' stamp: 'NickAger 12/12/2011 16:59'!
codeOn: aStream
	self javascriptOn: aStream! !

!Collection methodsFor: '*pier-exporter-code' stamp: 'NickAger 12/11/2011 20:49'!
codeOn: aStream
	aStream << '#('.
	self do: [ :each |
		each codeOn: aStream ].
	aStream << ')'! !
